/*
  Name: keyStatesClass.cpp
  Copyright: Polecatsoft 2005
  Game: Tough Terry
  Author: Master Lenman
  Date: 16.07.05 14:43
  Description: This class allows to get the state of a key,
	  but you cannot hold down the key
*/

#include <allegro.h>
#include <string>

#include "keyStatesClass.h"

using namespace std;

keyStatesClass keyStates;

keyStatesClass::keyStatesClass()
{
	resetAll();
}

int keyStatesClass::operator [](int id)
{
	return getKey(id);
}

int keyStatesClass::getKey(int id)
{
	if(id >= KEY_MAX || id < 0)
		return false;
	if(key[id] && !pressedKeys[id])
	{
		pressedKeys[id] = true;
		return 1;
	}
	if(!key[id])
		pressedKeys[id] = false;
	return 0;
}

bool keyStatesClass::anyKey()
{
	for(int i = 0; i < KEY_MAX; ++i)
	{
		if(getKey(i))
			return true;
	}
	return false;
}

void keyStatesClass::resetAll()
{
	for(int i = 0; i < KEY_MAX; ++i)
		pressedKeys[i] = false;
}

void keyStatesClass::setState(int id, int value)
{
	pressedKeys[id] = value;
}

const string keyNames[KEY_MAX] = 
{
	"NULL",
	"A",
	"B",
	"C",
	"D",
	"E",
	"F",
	"G",
	"H",
	"I",
	"J",
	"K",
	"L",
	"M",
	"N",
	"O",
	"P",
	"Q",
	"R",
	"S",
	"T",
	"U",
	"V",
	"W",
	"X",
	"Y",
	"Z",
	"0",
	"1",
	"2",
	"3",
	"4",
	"5",
	"6",
	"7",
	"8",
	"9",
	"Numpad 0",
	"Numpad 1",
	"Numpad 2",
	"Numpad 3",
	"Numpad 4",
	"Numpad 5",
	"Numpad 6",
	"Numpad 7",
	"Numpad 8",
	"Numpad 9",
	"F1",
	"F2",
	"F3",
	"F4",
	"F5",
	"F6",
	"F7",
	"F8",
	"F9",
	"F10",
	"F11",
	"F12",
	"Esc",
	"Tilde",
	"Minus",
	"Equals",
	"Backspace",
	"Tab",
	"Openbrace",
	"Closebrace",
	"Enter",
	"Colon",
	"Quote",
	"\\",
	"\\",
	",",
	".",
	"/",
	"Space",
	"Insert",
	"Delete",
	"Home",
	"End",
	"Page up",
	"Page down",
	"Left",
	"Right",
	"Up",
	"Down",
	"Numpad /",
	"Numpad *",
	"Numpad -",
	"Numpad +",
	"Numpad Delete",
	"Numpad Enter",
	"Print screen",
	"Pause",
	"ABNT_C1",
	"Yen",
	"Kana",
	"CONVERT",
	"NOCONVERT",
	"@",
	"Circumflex",
	"Colon 2",
	"KANJI",
	"Numpad =",
	"Backquote",
	"Semicolon",
	"Command Key",
	"Unknown1",
	"Unknown2",
	"Unknown3",
	"Unknown4",
	"Unknown5",
	"Unknown6",
	"Unknown8",
	"MODIFIERS",
	"Left Shift",
	"Right Shift",
	"Left Ctrl",
	"Right Ctrl",
	"Alt",
	"Alt Gr",
	"Left windows",
	"Right windows",
	"MENU",
	"Screenlock",
	"Numlock",
	"Capslock"
};
